#include<awali/sttc/automaton.hh>
#include<awali/sttc/factories/ladybird.hh>
#include<awali/sttc/algos/restriction.hh>

using namespace awali;
using namespace awali::sttc;

template<typename Aut>
void test(Aut aut, unsigned alph_size, unsigned num_trans) {
  require(aut->context().labelset()->genset().size()==alph_size, "Wrong number of letters");
  require(aut->num_transitions()==num_trans, "Wrong number of transitions");
}

int main() {
  auto aut=make_automaton({'a','b','c'});
  auto lady = ladybird(aut->context(), 3);
  test(lady,3,9);
  change_alphabet(lady, {'a','b'});
  test(lady,2,5);
  //js_print(lady, std::cout) << std::endl;
  lady = ladybird(aut->context(), 3);
  remove_letters(lady, {'c'});
  test(lady,2,5);
  //js_print(lady, std::cout) << std::endl;
}

